#include"AneuMeshLoader.h"

void AneuMeshLoader::LoadMesh(const std::string& P)
{
        std::ifstream f_in;
        f_in.open(P);

        if (!f_in.is_open())
	{
		throw std::exception("file cannot be open ");
	}
        sizeT amount;
	double x, y, z;
        sizeT size;
        f_in >> amount;
        f_in >> size;
	node.reserve(amount);

	for (int i = 1; i <= amount; i++)
	{
                f_in >> x >> y >> z;
		node.push_back(Node(x, y, z, i));
	}
        f_in >> amount;
        sizeT count_node;
        f_in >> count_node;
        sizeT N1, N2, N3, N4,id_material;
        finelem.reserve(amount);

	for (int i = 1; i <= amount; i++)
	{
                f_in >>id_material>> N1 >> N2 >> N3 >> N4;
                node[N1_1].top = true;
                node[N2_1].top = true;
                node[N3_1].top = true;
                node[N4_1].top = true;
                finelem.push_back(FiniteElemement(id_material, N1, N2, N3, N4, i));
	}

        f_in >> amount;
        f_in >> count_node;
        sizeT idSurface;
        boundelem.reserve(amount);

	for (int i = 1; i <= amount; i++)
	{
                f_in >> idSurface >> N1 >> N2 >> N3;
                node[N1_1].top = true;
                node[N2_1].top = true;
                node[N3_1].top = true;
                boundelem.push_back(BoundaryFiniteElement(idSurface,N1,N2,N3,i)) ;
	}
        f_in.close();
}
